{$F+,O+}
UNIT keynames;
{Version 1.01, October 1990 - 1.02, December 1997}
{1.03, December 1999: Olivetti Keyboard 2 keystrokes withdrawn;
names F13k thru F40k for function keys withdrawn;
industrial-standard F11 and F12 keystrokes added on the occasion
of a new CRT unit in TURBO.TPL; see \TP7\CRTFIX\README*.TXT for details}
{Remark:
Most names do not contain the letter k as an abbreviation of "key";
Some do so to diminuish the chance of duplicate identifiers; they are:
     1) all cursor movement key names,
        including those with Shift and Ctrl prefixed;
     2) all function key names which begin with "F";
     3) BSk, TABk, BackTABk, Endk.
}
{1.04, April 2001: Keystroke names CtrlLArrow and CtrlRArrow added}

INTERFACE USES crt;

{Extended keyboard codes in Turbo-PASCAL:}
{Turbo-PASCAL version 3: XSC = #27; versions 4 and later: XSC = #0}
const XSC  =  #0;


{Simple keyboard codes}
{}

{Single keystrokes:}
{}
{Remark:
Letters, digits and special characters do not receive a name of their own.}
const BSk      =  #8; {Delete character left of cursor and move cursor
                       one position to the left}
      TABk     =  #9;
      CR       = #13;
      ENTER    = #13;
      ESC      = #27;
      SPACEBAR = #32;


{With Shift key:}
{}
const ShiftNk   = #56; ShiftNEk  = #57; ShiftEk   = #54; ShiftSEk  = #51;
      ShiftSk   = #50; ShiftSWk  = #49; ShiftWk   = #52; ShiftNWk  = #55;
      Shift5k   = #53;
const ShiftHome = #55; ShiftEndk = #49; ShiftPgUp = #57; ShiftPgDn = #51;
const ShiftINS  = #48;
      ShiftDEL  = #46;

{With Ctrl key:}
{}
const CtrlA =  #1; CtrlB =  #2; CtrlC =  #3; CtrlD =  #4; CtrlE =  #5;
      CtrlF =  #6; CtrlG =  #7; CtrlH =  #8; CtrlI =  #9; CtrlJ = #10;
      CtrlK = #11; CtrlL = #12; CtrlM = #13; CtrlN = #14; CtrlO = #15;
      CtrlP = #16; CtrlQ = #17; CtrlR = #18; CtrlS = #19; CtrlT = #20;
      CtrlU = #21; CtrlV = #22; CtrlW = #23; CtrlX = #24; CtrlY = #25;
      CtrlZ = #26;
const CtrlESC = #27; CtrlCaret = #30; CtrlUnderscore = #31;
      CtrlBackSlash = #28; CtrlBS = #127;
      CtrlLSqBr = #27; CtrlRSqBr = #29;
      CtrlCR = #10; CtrlENTER = #10;



{Extended keyboard codes (subcases of case XSC):}
{}

{Single keystrokes:}
{}
const F1k = #59; F2k = #60; F3k = #61; F4k = #62; F5k = #63;
      F6k = #64; F7k = #65; F8k = #66; F9k = #67; F10k = #68;
      F11k = #133; F12k = #134;
(*
      {F11..F18: Olivetti PC Keyboard 2 only}
const F11k = #84; F12k = #85;F13k = #86; F14k = #87; F15k = #88;
      F16k = #89; F17k = #90; F18k = #91;
*)
const Nk   = #72; NEk  = #73; Ek   = #77; SEk  = #81;
      Sk   = #80; SWk  = #79; Wk   = #75; NWk  = #71;
const Home = #71; Endk = #79; PgUp = #73; PgDn = #81;
const INS  = #82;
      DEL  = #83; {Delete character at cursor}

(*
{Numbers 1..40 for Function Keys:}
{}
{F1k .. F18k defined above}
const F19k =  #92; F20k =  #93;
const F21k =  #94; F22k =  #95; F23k =  #96; F24k =  #97; F25k =  #98;
      F26k =  #99; F27k = #100; F28k = #101; F29k = #102; F30k = #103;
const F31k = #104; F32k = #105; F33k = #106; F34k = #107; F35k = #108;
      F36k = #109; F37k = #110; F38k = #111; F39k = #112; F40k = #113;
*)


{With Shift key:}
{}
const BackTABk = #15;
const ShiftF1 = #84; ShiftF2 = #85; ShiftF3 = #86; ShiftF4 = #87;
      ShiftF5 = #88; ShiftF6 = #89; ShiftF7 = #90; ShiftF8 = #91;
      ShiftF9 = #92; ShiftF10 = #93;
      ShiftF11 = #135; ShiftF12 = #136;


{With Ctrl key:}
{}
const CtrlAt = #3; CtrlPrtSc = #114;
const NEkk = #132; Ekk  = #116; SEkk = #118;
      SWkk = #117; Wkk  = #115; NWkk = #119;
const CtrlHome = #119; CtrlEndk = #117;
      CtrlPgUp = #132; CtrlPgDn = #118;
      CtrlLArrow = #115; CtrlRArrow = #116;
const CtrlF1 =  #94; CtrlF2 =  #95; CtrlF3 =  #96; CtrlF4 =  #97;
      CtrlF5 =  #98; CtrlF6 =  #99; CtrlF7 = #100; CtrlF8 = #101;
      CtrlF9 = #102; CtrlF10 = #103;
      CtrlF11 = #137; CtrlF12 = #138;

{With Alt key:}
{}
const Alt1 =  #120; Alt2 =  #121; Alt3 =  #122; Alt4 =  #123; Alt5 =  #124;
      Alt6 =  #125; Alt7 =  #126; Alt8 =  #127; Alt9 =  #128; Alt0 =  #129;
      AltMinus = #130; AltEquals = #131;
const AltQ =   #16; AltW =   #17; AltE =   #18; AltR =   #19; AltT =   #20;
      AltY =   #21; AltU =   #22; AltI =   #23; AltO =   #24; AltP =   #25;
const AltA =   #30; AltS =   #31; AltD =   #32; AltF =   #33; AltG =   #34;
      AltH =   #35; AltJ =   #36; AltK =   #37; AltL =   #38;
const AltZ =   #44; AltX =   #45; AltC =   #46; AltV =   #47; AltB =   #48;
      AltN =   #49; AltM =   #50;
const AltF1 = #104; AltF2 = #105; AltF3 = #106; AltF4 = #107; AltF5  = #108;
      AltF6 = #109; AltF7 = #110; AltF8 = #111; AltF9 = #112; AltF10 = #113;
      AltF11 = #139; AltF12 = #140;

{Universally used types:}
type s1 = string[1]; type s2 = string[2];
type s3 = string[3]; type s4 = string[4];

procedure rkb (var s: s2);
{------------------------}
{PURPOSE: Read any simple or composite keyboard input recognisable by ReadKey}


IMPLEMENTATION

procedure rkb (var s: s2);
{------------------------}
{PURPOSE: Read any simple or composite keyboard input recognisable by ReadKey}
var ch: char;
begin
 ch := ReadKey; s := ch;
 if ch = XSC then begin ch := ReadKey; s := s + ch; end;
end; {rkb}

begin
 (*write ('KEYNAMES v1.03-1999 ');*)
 (*write ('KEYNAMES v1.04-2001 ');*) (*2.00 identical to 1.04*)
 write ('KEYNAMES v2.00-2001 ');
end.
