{$F+,O+}
UNIT ksgets;

INTERFACE USES crt, keynames, kstypvar, ksputs;

procedure kapaf (var s: stringMaxL);
procedure strip (var s: stringMaxL);
procedure beep;
procedure poscursor (line, col, pos: integer);
procedure getstringaa
          (var instring: stringMaxL; line, col, attrib, strlength,
          endmode, cmode: integer; var cursorpos: integer;
          {Wijzigingsstatus tonen?} statusind: boolean;
          {Zoja, waar op scherm?} stline, stcol: integer;
          {Welke boodschap?} stmsg: stringMaxL;
          {Toets waarmee getstringaa besloten werd:} var endkey: movement;
          {Toets waarmee getstringaa besloten werd:} var endchars: s2;
          {NB: Twee voorstellingen van hetzelfde}
          {Oorspronkelijke instring gewijzigd?} var veranderd: boolean;
          {Overloop toegestaan?} overloop_toegestaan: boolean;
          {Overloop vond plaats?} var overloop_vond_plaats: boolean;
          {Zo ja, opvang voor 1 overloopteken:} var opvang: char);
procedure getstringa
          (var instring: stringMaxL; line, col, attrib, strlength,
          endmode, cmode: integer; var cursorpos: integer;
          {Wijzigingsstatus tonen?} statusind: boolean;
          {Zoja, waar op scherm?} stline, stcol: integer;
          {Welke boodschap?} stmsg: stringMaxL;
          {Toets waarmee getstringa besloten werd:} var endkey: movement;
          {Oorspronkelijke instring gewijzigd?} var veranderd: boolean);
procedure getstring (var instring: stringMaxL; line, col, attrib, strlength: integer);
procedure getpromptedstring (var instring: stringMaxL; attrib, strlength: integer;
                             descstr: stringMaxL; descline, desccol: integer;
                             prompt: stringMaxL; prline, prcol: integer;
                             newline: boolean);

IMPLEMENTATION

procedure kapaf (var s: stringMaxL);
{----------------------------------}
{Kapt blanko staart af.}
var i: integer;
begin
 i := length (s);
 while ((s[i] = ' ') and (i > 0)) do begin delete (s, i, 1); i := i - 1; end;
end; {kapaf}

procedure strip (var s: stringMaxL);
{----------------------------------}
{PURPOSE: Ontdoet s van blanko kop en blanko staart.}
begin
 while (length (s) > 0) and (s[1] = ' ') do delete (s, 1, 1);
 while (length (s) > 0) and (s[length (s)] = ' ') do delete (s, length (s), 1);
end; {strip}

procedure beep;
{-------------}
{PURPOSE: Audible error signal; (Author: Ruud Breevoort) NOTES: Replaces "write (char (bell))"}
var i,j,r: integer;
begin
 for r:= 1 to 20 do
 begin
  j:=2000 + r * 80;
  for i := 1 to 50 do
  begin
   sound(j);
   (*j:=j-10;*)
  end;
 end;
 nosound;
end; {beep}

procedure poscursor (line, col, pos: integer);
{--------------------------------------------}
{
PURPOSE: Positions cursor at POS relative to COL at line LINE. (COL ~ POS = 1)}
begin ganaarxy (col + pos - 1, line); end;

procedure Complement (var s: stringMaxL; var i: integer; b: integer);
{-------------------------------------------------------------------}
{PURPOSE: Take the opposite of the number represented by the input string "s"
from position "a" up to and including position "b",
and discard the sign change}
{PRE: b >= i and no characters outside ['0'..'9', '-', '+', '.', ',', ' ']}
{Blanks and plus and minus signs are treated like zeros.
Comma and period signs are skipped.}
var z: integer;
begin
 {Set pointer z to the first of trailing zeros if present, otherwise set it
 just beyond the substring:}
 {To end of substring:}
 z := b;
 {Go backward if and as long as '0', '.' or ',' or blank is found:}
 {Assert z >= i because of precondition}
 while (z >= i) and (s[z] in ['0', ',', '.', ' ']) do z := z - 1;
 {Assert z >= i - 1}
 z := z + 1;
 {Assert z >= i}
 {9-Complement input up to first trailing zero:}
 {Assert i <= z}
 while i < z do
 begin
  if s[i] in ['0'..'9']
  then s[i] := chr (ord ('9') - ord (s[i]) + ord ('0'))
  {Blanks and plus and minus signs treated like zeros:}
  else if s[i] in [' ', '-', '+'] then s[i] := '9';
  i := i + 1;
 end; {while i < z}
 {Assert i >= z, therefore i = z}
 {Last digit 10-complement instead of 9-complement:}
 s[i - 1] := chr (ord (s[i - 1]) + 1);
end; {Complement}

procedure setsign (var s: stringMaxL; c: char);
{---------------------------------------------}
{PURPOSE: Give an explicit sign ("c", typically '+' or '-') to the number
represented by string "s". To this end, search for the position just
preceding the first digit or decimal point of "s", and copy "c" there
if "s" does not start with digit or deciaml point.}
var i: integer;
begin
 i := 1;
 while (i <= length (s)) and not (s[i] in ['0'..'9', '.']) do i := i + 1;
 i := i - 1;
 if i >= 1 then s[i] := c;
end; {setsign}


procedure verhoogstring (var s: stringMaxL; pos: integer);
{--------------------------------------------------------}
{Thumbwheel feature}
{PRE: "pos" wijst een teken in "s" aan.}
var ELocation: integer; {Location of exponent part (begins with 'E' or 'e')}
var auxs: stringMaxL; {auxiliary copy of original string "s"}
var PZN: char; {Positive / Zero / Negative indicator}
var i: integer;
begin
 {Locate exponent part - search for 'e' or 'E':}
 i := 1; while (i <= length (s)) and (Upcase (s[i]) <> 'E') do i := i + 1;
 ELocation := i;
 {String "auxs" is for inspection only:}
 auxs := s;
 strip (auxs);
 {If sign present then set PZN accordingly, and remove it from auxs string}
 case auxs[1] of
 '+': begin PZN := 'P'; delete (auxs, 1, 1); end; {'+'}
 '-': begin PZN := 'N'; delete (auxs, 1, 1); end; {'-'}
 else PZN := 'P';
 end; {case s[1]}
 {Zero or nonzero?}
 i := 1;
 while (i <= length (auxs)) and (auxs[i] = '0') do
 begin
  i := i + 1;
  {Skip period and comma characters:}
  if (i <= length (auxs)) and (auxs[i] in ['.', ',']) then i := i + 1;
 end; {while}
 if (i > length (auxs)) {String exhausted}
 or ((i <= length (auxs)) and (Upcase (auxs[i]) = 'E')) {End of floating-point fraction}
 then PZN := 'Z';
 {Perform increment:}
 case PZN of
 'P', 'Z': begin
            {-0.0 with thumbwheel increment action on minus sign remained 0.0
            but should become 10.0: successfully repaired}
            if s[pos] = '-' then s[pos] := ' '; {Added April 5th 2005}
            case s[pos] of
            '0'..'8':
            begin
             s[pos] := chr (ord (s[pos]) + 1);
            end; {'0'..'8'}
            '9':
            begin
             i := pos;
             while (i >= 1) and (s[i] = '9') do
             begin
              s[i] := '0'; i := i - 1;
              {Skip period and comma characters:}
              if (i >= 1) and (s[i] in ['.', ',']) then i := i - 1;
             end; {while}
             if i >= 1
             then case s[i] of
                  '0'..'9': begin
                             s[i] := chr (ord (s[i]) + 1);
                            end; {'0'..'9'}
                  ' ', '+': begin
                             s[i] := '1';
                            end; {' '}
                  end; {case s[i]}
            end; {'9'}
            ' ', '+':
            begin
             s[pos] := '1';
             i := pos + 1;
             while (i <= length (s)) and (s[i] in [' ', '+', '-']) do
             begin
              s[i] := '0'; i := i + 1;
              {Skip period and comma characters:}
              if (i <= length (s)) and (s[i] in ['.', ','])
              then i := i + 1;
             end; {while}
            end; {' ', '+'}
            end; {case s[pos]}
            setsign (s, '+');
           end; {case PNZ = 'P', 'Z'}
 'N':      case s[pos] of
           '0':
           begin
            i := pos;
            while (i >= 1) and (s[i] = '0') do
            begin
             s[i] := '9'; i := i - 1;
             {Skip period and comma characters:}
             if (i >= 1) and (s[i] in ['.', ',']) then i := i - 1;
            end; {while}
            if i >= 1
            then case s[i] of
                 '1'..'9':
                 s[i] := chr (ord (s[i]) - 1);
                 '-': {Traverse zero - 1st:}
                 {I.E. Change sign and complement:}
                 {Now "i" is at the minus sign and "pos" is at the cursor}
                 begin
                  s[i] := '+'; i := i + 1;
                  Complement (s, i, ELocation - 1);
                 end; {'-'} {Traverse zero - 1st}
                 end; {case s[i]}
           end; {'0'}
           '1'..'9':
           s[pos] := chr (ord (s[pos]) - 1);
           '-', ' ': {Traverse zero - 2nd}
           begin
            s[pos] := '+';
            i := pos;
            {Complement the digits beyond the sign:}
            i := i + 1;
            Complement (s, i, ELocation - 1);
           end; {'-', ' '} {Traverse zero - 2nd}
           end; {case s[pos]}
 end; {case PZN}
end; {verhoogstring}

procedure verlaagstring (var s: stringMaxL; pos: integer);
{--------------------------------------------------------}
{Thumbwheel feature}
{PRE: "pos" wijst een teken in "s" aan.}
var ELocation: integer; {Location of exponent part (begins with 'E' or 'e')}
var auxs: stringMaxL; {auxiliary copy of original string "s"}
var PZN: char; {Positive / Zero / Negative indicator}
var i: integer;
begin
 {Locate exponent part - search for 'e' or 'E':}
 i := 1; while (i <= length (s)) and (Upcase (s[i]) <> 'E') do i := i + 1;
 ELocation := i;
 {String "auxs" is for inspection only:}
 auxs := s; strip (auxs);
 {If sign present then set PZN accordingly, and remove it from auxs string}
 case auxs[1] of
 '+': begin PZN := 'P'; delete (auxs, 1, 1); end; {'+'}
 '-': begin PZN := 'N'; delete (auxs, 1, 1); end; {'-'}
 else PZN := 'P';
 end; {case s[1]}
 {Zero or nonzero?}
 i := 1;
 while (i <= length (auxs)) and (auxs[i] = '0') do
 begin
  i := i + 1;
  {Skip period and comma characters:}
  if (i <= length (auxs)) and (auxs[i] in ['.', ',']) then i := i + 1;
 end; {while}
 if (i > length (auxs)) {String exhausted}
 or ((i <= length (auxs)) and (Upcase (auxs[i]) = 'E')) {End of floating-point fraction}
 then PZN := 'Z';
 {Perform decrement:}
 case PZN of
 'N', 'Z': begin
            {+0.0 with thumbwheel decrement action on plus sign remained 0.0
            but should become -10.0: successfully repaired}
            if s[pos] = '+' then s[pos] := ' '; {Added April 5th 2005}
            case s[pos] of
            '0'..'8':
            begin
             s[pos] := chr (ord (s[pos]) + 1);
            end; {'0'..'8'}
            '9':
            begin
             i := pos;
             while (i >= 1) and (s[i] = '9') do
             begin
              s[i] := '0'; i := i - 1;
              {Skip period and comma characters:}
              if (i >= 1) and (s[i] in ['.', ',']) then i := i - 1;
             end; {while}
             if i >= 1
             then case s[i] of
                  '0'..'9': begin
                             s[i] := chr (ord (s[i]) + 1);
                            end; {'0'..'9'}
                  ' ', '-': begin
                             s[i] := '1';
                            end; {' '}
                  end; {case s[i]}
            end; {'9'}
            ' ', '-':
            begin
             s[pos] := '1';
             i := pos + 1;
             while (i <= length (s)) and (s[i] in [' ', '+', '-']) do
             begin
              s[i] := '0'; i := i + 1;
              {Skip period and comma characters:}
              if (i <= length (s)) and (s[i] in ['.', ','])
              then i := i + 1;
             end; {while}
            end; {' ', '-'}
            end; {case s[pos]}
            setsign (s, '-');
           end; {case PNZ = 'N', 'Z'}
 'P':      case s[pos] of
           '0':
           begin
            i := pos;
            while (i >= 1) and (s[i] = '0') do
            begin
             s[i] := '9'; i := i - 1;
             {Skip period and comma characters:}
             if (i >= 1) and (s[i] in ['.', ',']) then i := i - 1;
            end; {while}
            if i >= 1
            then case s[i] of
                 '1'..'9':
                 s[i] := chr (ord (s[i]) - 1);
                 '+', ' ': {Traverse zero - 1st:}
                 {I.E. Change sign and complement:}
                 {Now "i" is at the plus sign and "pos" is at the cursor}
                 begin
                  s[i] := '-'; i := i + 1;
                  Complement (s, i, ELocation - 1);
                 end; {'+', ' '} {Traverse zero - 1st}
                 end; {case s[i]}
           end; {'0'}
           '1'..'9':
           s[pos] := chr (ord (s[pos]) - 1);
           '+', ' ': {Traverse zero - 2nd}
           begin
            s[pos] := '-';
            i := pos;
            {Complement the digits beyond the sign:}
            i := i + 1;
            Complement (s, i, ELocation - 1);
           end; {'+', ' '} {Traverse zero - 2nd}
           end; {case s[pos]}
 end; {case PZN}
end; {verlaagstring}

procedure getstringaa
          (var instring: stringMaxL; line, col, attrib, strlength,
          endmode, cmode: integer; var cursorpos: integer;
          {Wijzigingsstatus tonen?} statusind: boolean;
          {Zoja, waar op scherm?} stline, stcol: integer;
          {Welke boodschap?} stmsg: stringMaxL;
          {Toets waarmee getstringaa besloten werd:} var endkey: movement;
          {Toets waarmee getstringaa besloten werd:} var endchars: s2;
          {NB: Twee voorstellingen van hetzelfde}
          {Oorspronkelijke instring gewijzigd?} var veranderd: boolean;
          {Overloop toegestaan?} overloop_toegestaan: boolean;
          {Overloop vond plaats?} var overloop_vond_plaats: boolean;
          {Zo ja, opvang voor 1 overloopteken:} var opvang: char);
{------------------------------------------------------------------------}
{
PURPOSE: Inputs a string at given location with given video attribute.}
{Completion of getstringaa routine:}
{The keystroke completing the getstringaa routine will always be recorded in
the output parameter "endchars".}
{endmode = 0xx: "instring" is valid up to, but excluding the cursor position;
                if, however, the cursor is at begin of field or has not been
                moved, then the full-length current "instring" is valid.
                Anyhow, its blank tail will be chopped off.}
{endmode = 1xx: the full-length current "instring" parameter is valid.}
{endmode = 2xx: "instring" is right-padded with blanks to length "strlength".}
{endmode = 1, 101, 201: getstringaa is completed by CR.}
{endmode = 2, 102, 202: (to be used with PANEEL.PAS (or PANEL.PAS in TP version 4))
                        completed by arrow keys NEk, SEk,
                        by TAB    ("endkey" will be set to "Forth".),
                        Shift-TAB ("endkey" will be set to "Back".),
                        Nk, Sk:   (Numerical contents of field will be incremented/
                                  decremented by unity at the cursor position.)
                        by Alt-a..Alt-z, Alt-1..Alt-0,
                        F1..F10, ShiftF4..F10, CtrlF1..F10, AltF1..F10,
                        by Ctrl-a..g, k..o, r..x, z,
                        by ESC = #27, CtrlESC = #27, CtrlCaret = #30,
                        CtrlUnderscore = #31, CtrlBackSlash = #28,
                        CtrlBS = #127, CtrlLSqBr = #27, CtrlRSqBr = #29,
                        CtrlJ = #10, CtrlCR = CtrlENTER = #10.
                        ("endkey" will be set to "none".), and by CR too.}
{endmode = 3, 103, 203: (to be used with DATAENTR.PAS)
                        completed by CR as well as
                        by TAB    ("endkey" will be set to "Forth".),
                        Shift-TAB ("endkey" will be set to "Back".).}
{endmode = 4, 104, 204: (to be used with PANEEL.PAS (or PANEL.PAS in TP version 4))
                        completed by arrow keys Nk, Sk, NEk, SEk,
                        by TAB    ("endkey" will be set to "Forth".),
                        Shift-TAB ("endkey" will be set to "Back".),
                        by Alt-a..Alt-z, Alt-1..Alt-0,
                        F1..F10, ShiftF4..F10, CtrlF1..F10, AltF1..F10,
                        by Ctrl-a..g, k..o, r..x, z,
                        by ESC = #27, CtrlESC = #27, CtrlCaret = #30,
                        CtrlUnderscore = #31, CtrlBackSlash = #28,
                        CtrlBS = #127, CtrlLSqBr = #27, CtrlRSqBr = #29,
                        CtrlJ = #10, CtrlCR = CtrlENTER = #10.
                        ("endkey" will be set to "none".), and by CR too.}
{overloop_toegestaan = true: completed according to "endmode", and by input string overflow too;
actual overflow indicated by "overloop_vond_plaats"; overflow character recorded in "opvang".}
{cmode = 1: if cursorpos = 0 then cursor initially at first position of instring;}
{cmode = 2: if cursorpos = 0 then cursor initially at first nonblank position of instring}
var   oldstr, tempstr: stringMaxL; kbdch1, kbdch2, inchar: char; i, pos, first, last: integer;
      insrt: boolean; einde: boolean; eerstekeer: boolean; x, y: integer;
      prefix: boolean; nnb: {nognietbewogen} boolean;

procedure plaats; {Breng teken "kbdch1" als datateken op zijn plaats.}
{NB: Geen parameters en geen lokale variabelen}
{Overloop: indien toegestaan, dan alleen doen indien invoerveld vol is en de
kursor vlak voorbij het invoerveld staat, dus alleen
if (length (instring) = strlength) and (pos = length (instring) + 1)}

procedure loopover;
begin
 einde := true; overloop_vond_plaats := true;
 opvang := kbdch1; endchars[0] := #1; endchars[1] := kbdch1;
end;

{--- procedure plaats: body ---}

begin
 if   insrt
 then
 begin
  if length (instring) < strlength
  then
  begin
   insert (kbdch1, instring, pos); veranderd := true;
   showstring (instring, line, col, attrib, strlength);
   pos := pos + 1; poscursor (line, col, pos);
  end
  else if ((pos = length (instring) + 1) and overloop_toegestaan)
       then loopover
       else beep;
 end
 else
 begin
  if pos <= length (instring)
  then
  begin
   instring[pos] := kbdch1; veranderd := true;
   showstring (instring, line, col, attrib, strlength);
   pos := pos + 1; poscursor (line, col, pos);
  end
  else if pos < strlength + 1
  then
  begin
   instring[0] := chr (length (instring) + 1);
   instring[pos] := kbdch1; veranderd := true;
   showstring (instring, line, col, attrib, strlength);
   pos := pos + 1; poscursor (line, col, pos);
  end
  else if overloop_toegestaan then loopover else beep;
 end;
end; {plaats}

{--- procedure getstringaa: body ---}

begin
 einde := false;
 eerstekeer := true;
 nnb := true;
 prefix := false;
 oldstr := instring;
 showstring (instring, line, col, attrib, strlength);
 {Indien geen overloop van vorige aanroep:
 Zet kursor op eerste teken of op eerste niet-blank teken al naarmate verlangd;
 indien wel overloop, dan kursor op positie #2.}
 if not overloop_vond_plaats
 then
 begin
  if cursorpos = 0
  then
  begin
   pos := 1;
   if cmode = 2
   then
   begin
    if (length (instring) > 1)
    then
    begin
     while ((instring[pos] = ' ') and (pos <= length (instring))) do pos := pos + 1;
     if (pos > length (instring)) then pos := length (instring);
     if ((pos = length (instring)) and (instring[pos] = ' ')) then pos := 1;
    end;
   end; {if cmode = 2}
  end
  else begin pos := cursorpos; cursorpos := 0; end;
 end
 else begin pos := 2; overloop_vond_plaats := false; end;
 poscursor (line, col, pos);
 insrt := false;
 (*if ord (kbdch1) <> CR then instring := '';*)
 while not einde do
 begin
  kbdch1 := readkey;
  if not prefix
  then
  case kbdch1 of
  {CASE-elementen: besturingstekens; ELSE-tak van de CASE-opdracht: datatekens}
  {-----}
  CR:  begin einde := true; endchars[0] := #1; endchars[1] := kbdch1; end;
  #1..#7, #11..#15, #18..#24, #26, {Ctrl-a..g, k..o, r..x, z}
  ESC, #28..#31, #10, #127: {ESC, ..., Ctrl-j, Ctrl-BS}
  if endmode mod 100 in [2, 4]
  then begin einde := true; endchars[0] := #1; endchars[1] := kbdch1; end
  else plaats;
  {-----}
  BSk:
  begin
   if   pos > 1
   then
   begin
    delete (instring, pos - 1, 1);
    nnb := false; veranderd := true;
    showstring (instring, line, col, attrib, strlength);
    pos := pos - 1; poscursor (line, col, pos);
   end
   else beep;
  end;
  {-----}
  CtrlY:
  begin
   nnb := false;
   veranderd := true;
   instring[0] := chr (0); showstring (instring, line, col, attrib, strlength);
   pos := 1; poscursor (line, col, pos);
  end;
  {-----}
  CtrlP: prefix := true;
  {-----}
  TABk:
  case endmode mod 100 of 2, 3, 4:
  begin einde := true; endchars[0] := #1; endchars[1] := kbdch1; end;
  end; {case}
  {-----}
  CtrlQ:
  begin
   kbdch2 := readkey;
   case kbdch2 of
   CtrlL:
        begin
         instring := oldstr;
         nnb := true; veranderd := false;
         showstring (instring, line, col, attrib, strlength);
         {Zet kursor op eerste teken of op eerste niet-blank teken al naarmate verlangd.}
         pos := 1;
         if cmode = 2
         then
         begin
          if (length (instring) > 1)
          then
          begin
           while ((instring[pos] = ' ') and (pos <= length (instring))) do pos := pos + 1;
           if (pos > length (instring)) then pos := length (instring);
           if ((pos = length (instring)) and (instring[pos] = ' ')) then pos := 1;
          end;
         end; {if cmode = 2}
         poscursor (line, col, pos);
        end;
   CtrlY:
        begin
         while (pos < length (instring) + 1) do
         begin delete (instring, pos, 1); veranderd := true; end;
         showstring (instring, line, col, attrib, strlength);
         {pos := pos;} poscursor (line, col, pos);
        end;
       end; {case kbdch2}
  end; {CtrlQ}
  {-----}
  XSC:
  begin
   case   keypressed of
   true:  begin
           kbdch2 := readkey;
           case kbdch2 of
           {-----}
           AltQ..AltP, AltA..AltL,
           AltZ..AltM, Alt1..Alt0,
           F1k..F10k, ShiftF4..ShiftF10, CtrlF1..CtrlF10, AltF1..AltF10:
           begin
            if endmode mod 100 in [2, 4]
            then
            begin
             einde := true;
             endchars[0] := #2;
             endchars[1] := #0;
             endchars[2] := kbdch2;
            end;
           end;
           {-----}
           ShiftF1:
           begin
            if   length (oldstr) > length (instring)
            then
            begin
             nnb := false;
             veranderd := true;
             instring[0] := chr (length (instring) + 1);
             inchar := oldstr[ord (instring[0])];
             instring[ord (instring[0])] := inchar;
             showstring (instring, line, col, attrib, strlength);
             pos := pos + 1; poscursor (line, col, pos);
            end
            else beep;
           end; {ShiftF1}
           {-----}
           ShiftF3:
           begin
            while length (oldstr) > length (instring) do
            begin
             nnb := false;
             veranderd := true;
             instring[0] := chr (length (instring) + 1);
             inchar := oldstr[ord (instring[0])];
             instring[ord (instring[0])] := inchar;
            end; {while}
            showstring (instring, line, col, attrib, strlength);
            pos := length (instring) + 1; poscursor (line, col, pos);
           end; {ShiftF3}
           {-----}
           BackTABk:
           case endmode mod 100 of 2, 3, 4:
           begin einde := true; endchars[0] := #2; endchars[1] := #0; endchars[2] := kbdch2; end;
           end; {case endmode}
           {-----}
           Nk, NEk, SEk, Sk:
           case endmode mod 100 of 2, 4:
           begin einde := true; endchars[0] := #2; endchars[1] := #0; endchars[2] := kbdch2; end;
           end; {case endmode}
           {-----}
           NWk: begin
                 pos := 1; poscursor (line, col, pos);
                end;
           SWk: begin
                 pos := length (instring) + 1; poscursor (line, col, pos);
                end;
           Wk:  if pos > 1
                then
                begin
                 nnb := false;
                 pos := pos - 1; poscursor (line, col, pos);
                end
                else beep;
           Ek:  if pos < length (instring) + 1
                then
                begin
                 nnb := false;
                 pos := pos + 1; poscursor (line, col, pos);
                end
                else beep;
           Ekk: {Word Right (Auteur: Ruud Breevoort)}
                begin
                 nnb := false;
                 tempstr:= instring;
                 kapaf (tempstr); last := length (tempstr);
                 if tempstr[pos] <> ' ' then
                 begin
                  while (tempstr[pos] <> ' ') and (pos <= last) do
                  begin
                   pos := pos + 1;
                  end;
                 end;
                 while (tempstr[pos] = ' ') and (pos <= last) do
                 begin
                  pos := pos + 1;
                 end;
                 if pos > length (instring) then pos := length (instring);
                 poscursor (line, col, pos);
                end;
           Wkk: {Word Left (Auteur: Ruud Breevoort)}
                begin
                 nnb := false;
                 tempstr := instring;
                 kapaf (tempstr);
                 first := 1; last := length (tempstr);
                 tempstr := tempstr + ' ';
                 while (tempstr[first] = ' ') and (first <= last) do
                 begin
                  first :=  first + 1;
                 end;
                 if pos > first then
                 begin
                  if tempstr[pos] <> ' ' then
                  begin
                   while (tempstr[pos] <> ' ') and (pos >= first) do
                   begin
                    pos := pos - 1;
                   end;
                  end;
                  while (tempstr[pos] = ' ') and (pos >= first) do
                  begin
                   pos := pos - 1;
                  end;
                  while (tempstr[pos] <> ' ') and (pos >= first) do
                  begin
                   pos := pos - 1;
                  end;
                  pos := pos + 1;
                  poscursor (line, col, pos);
                 end;
                end;
           INS: insrt := not insrt;
           DEL: begin
                 if   (pos > 0) and (pos < length (instring) + 1)
                 then
                 begin
                  delete (instring, pos, 1); nnb := false; veranderd := true;
                  showstring (instring, line, col, attrib, strlength);
                  {pos := pos;} poscursor (line, col, pos);
                 end
                 else beep;
                end;
           {-----}
           end; {case ord(kbdch2)}
          end; {case true}
   false: begin
          end;
   end;   {case keypressed}
  end; {XSC}
  {-----}
  {Datatekens:}
  else begin nnb := false; plaats; end;
  end {if not prefix then case ord (kbdch1)}
  else begin prefix := false; nnb := false; plaats; end;
  {Toon wijzingsstatus indien verlangd:}
  if (statusind and veranderd and eerstekeer) then
  begin
   eerstekeer := false;
   x := waarx; y := waary;
   ganaarxy (stcol, stline); tekstcolor (STColor); tekstbackground (red);
   schrijfstring (stmsg);
   setvideo (normal);
   ganaarxy (x, y);
  end;
 end;  {while not einde}
 endkey := none;
 case endmode mod 100 of
 2,
 4:   begin
       if   kbdch1 = XSC
       then
       case kbdch2 of
       Nk:       endkey := No;
       NEk:      endkey := NE;
       SEk:      endkey := SE;
       Sk:       endkey := So;
       BackTABk: endkey := Back;
       end  {case}
       else
        case kbdch1 of
        TABk: endkey := Forth;
        end; {case}
      end; {endmode mod 100 = 2 or 4}
 3:   begin
       if kbdch1 = TABk
       then endkey := Forth
       else if (kbdch1 = XSC) and (kbdch2 = BackTABk)
            then endkey := Back;
      end; {endmode mod 100 = 3}
 end; {case endmode mod 100}
 case endmode div 100 of
 0: if (endkey <> No) and (endkey <> So)
    then
    {Indien kursor niet aan begin veld en bovendien bewogen, dan geldt "instring" totaan de kursor:}
    begin
     if (pos > 1) and not nnb then instring[0] := chr (pos - 1);
     kapaf (instring);
    end;
 2: geefblankostaart (instring, strlength);
 end; {case}
 case endmode mod 100 of
 2: begin
     case endkey of
     So: begin
          cursorpos := pos; verlaagstring (instring, pos); veranderd := true;
         end;
     No: begin
          cursorpos := pos; verhoogstring (instring, pos); veranderd := true;
         end;
     end; {case}
    end;
 end; {case}
 showstring (instring, line, col, attrib, strlength);
 {Toon wijzingsstatus indien verlangd:}
 if (statusind and veranderd and eerstekeer) then
 begin
  eerstekeer := false;
  x := waarx; y := waary;
  ganaarxy (stcol, stline); tekstcolor (STColor); tekstbackground (red);
  schrijfstring (stmsg);
  setvideo (normal);
  ganaarxy (x, y);
 end;
end;  {getstringaa}

procedure getstringa
          (var instring: stringMaxL; line, col, attrib, strlength,
          endmode, cmode: integer; var cursorpos: integer;
          {Wijzigingsstatus tonen?} statusind: boolean;
          {Zoja, waar op scherm?} stline, stcol: integer;
          {Welke boodschap?} stmsg: stringMaxL;
          {Toets waarmee getstringa besloten werd:} var endkey: movement;
          {Oorspronkelijke instring gewijzigd?} var veranderd: boolean);
{-----------------------------------------------------------------------}
{
PURPOSE: Inputs a string at given location with given video attribute.}
{Remark (NB): Is "getstringaa" zonder overloopmogelijkheid.}
var dummy1: boolean; dummy2: char; endchars: s2;
begin
 dummy1 := false;
 getstringaa (instring, line, col, attrib, strlength,
             endmode, cmode, cursorpos,
             {Wijzigingsstatus tonen?}
             statusind, stline, stcol, stmsg, endkey, endchars, veranderd,
             {Geen overloop toegestaan:} false, dummy1, dummy2);
end;

procedure getstring (var instring: stringMaxL; line, col, attrib, strlength: integer);
{------------------------------------------------------------------------------------}
{
PURPOSE: Inputs a string at given location with given video attribute.
Remark (NB):  Is "getstringa" zonder melding van wijzigingsstatus.}
var dummy0, dummy1, dummy2: integer; dummy3: stringMaxL; dummy4: movement; dummy5: boolean;
begin
 dummy0 := 0;
 getstringa (instring, line, col, attrib, strlength,
            {endmode:} 101, {cmode:} 2, dummy0,
            {Geen wijzingsstatus tonen:}
            false, dummy1, dummy2, dummy3,
            {Geen toetsaanslag waarmee "getstringa" besloten werd
            naar buiten doorgeven:} dummy4,
            {Gewijzigd-indikator niet naar buiten doorgeven:} dummy5);
end;

procedure getpromptedstring (var instring: stringMaxL; attrib, strlength: integer;
                            descstr: stringMaxL; descline, desccol: integer;
                            prompt: stringMaxL; prline, prcol: integer;
                            newline: boolean);
{--------------------------------------------------------------------------------}
{
PURPOSE: Inputs string at given location with given video attribute, meanwhile
highlighting a description and displaying a prompt.}
begin
 putprompt (prompt, prline, prcol);
 putstring (descstr, descline, desccol, bold);
 if newline
 then getstring
      (instring, descline + 1, desccol, attrib, strlength)
 else getstring
      (instring, descline, desccol + length (descstr), attrib, strlength);
 putstring (descstr, descline, desccol, normal);
end;

begin 
 (*write ('KSGETS   v1.00-1994 ');*)
 (*write ('KSGETS   v1.01-2001 ');*) (* Version 2.00 identical to 1.01 *)
 (*write ('KSGETS   v2.00-2001 ');*)
 (*write ('KSGETS   v2.01-2002 ');*)
 (*write ('KSGETS   v2.02-2003 ');*)
 (*write ('KSGETS   v2.03-2003 ');*)
 write ('KSGETS   v2.04-2005 ');
end.
